package hay.component;

import java.io.InputStream;
import java.util.ArrayList;

import android.content.ContentResolver;
import android.content.ContentUris;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.provider.ContactsContract;

public class HayContactAdapter {
	
	ContentResolver cr;
	
	public HayContactAdapter(ContentResolver cr) {
		this.cr = cr;
	}
	
	/**
	 * ش contact_id ּҷ  ´.
	 * @param contact_id ּҷ ̵
	 * @return Contact Ѵ. ش contact ٸ null Ѵ.
	 */
	public HayContact getContact(int contact_id){
		
		HayContact contact = new HayContact();
		
		Cursor cursor = cr.query(
				ContactsContract.Contacts.CONTENT_URI,  
				new String[] {ContactsContract.Contacts.HAS_PHONE_NUMBER,ContactsContract.Contacts.DISPLAY_NAME},
				ContactsContract.Contacts._ID + " = " + contact_id,
				null,
				null);  

		if(cursor.moveToNext()) {
			//ID,hasPhone ´.
			String hasPhone = cursor.getString(0);
			String name = cursor.getString(1);
			ArrayList<String> number = new ArrayList<String>();
			ArrayList<String> type = new ArrayList<String>();
			
			contact.setHasPhone(hasPhone.equals("1"));
			contact.setDisplay_name(name);			
			
			if (hasPhone.equals("1")){
				//ȣ  ´.
				Cursor phones = cr.query(  
						ContactsContract.CommonDataKinds.Phone.CONTENT_URI,  
						new String[] {ContactsContract.CommonDataKinds.Phone.TYPE,ContactsContract.CommonDataKinds.Phone.NUMBER},
						ContactsContract.CommonDataKinds.Phone.CONTACT_ID +" = "+ contact_id,  
						null,
						null);
				
				while(phones.moveToNext()) {
					
					//Ÿ
					int temp = phones.getInt(0);
					switch(temp){
					case 1: 
						type.add("");
						break;
					case 2: 
						type.add("");
						break;
					case 3: 
						type.add("");
						break;
					default : 
						type.add("Ÿ");
						break;
					}
					
					//ȣ 
					String stemp = phones.getString(1);
					number.add(stemp);
				}
				phones.close();
	
				contact.setPhone_number(number);
				contact.setPhone_type(type);
			}
		}
		else{
			return null;
		}
		
		return contact;
	}
	
	public Bitmap loadContactPhoto(long id) {
		Uri uri = ContentUris.withAppendedId(ContactsContract.Contacts.CONTENT_URI,id);
		InputStream input = ContactsContract.Contacts.openContactPhotoInputStream(cr, uri);

		if (input == null) {
			return null;
		}
		return BitmapFactory.decodeStream(input);
	}
}
